Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 956)
+++ lemon/lgf_writer.h	(revision 517)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -348,15 +348,17 @@
   }
 
-  template <typename DGR>
+  template <typename Digraph>
   class DigraphWriter;
 
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph,
-                                   std::ostream& os = std::cout);
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph, const std::string& fn);
-
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph, const char* fn);
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       std::ostream& os = std::cout);
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const std::string& fn);
+
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const char* fn);
 
 
@@ -380,5 +382,5 @@
   ///
   ///\code
-  /// DigraphWriter<DGR>(digraph, std::cout).
+  /// DigraphWriter<Digraph>(digraph, std::cout).
   ///   nodeMap("coordinates", coord_map).
   ///   nodeMap("size", size).
@@ -405,10 +407,10 @@
   /// the \c ostream() function, hence the second pass can append its
   /// output to the output of the first pass.
-  template <typename DGR>
+  template <typename _Digraph>
   class DigraphWriter {
   public:
 
-    typedef DGR Digraph;
-    TEMPLATE_DIGRAPH_TYPEDEFS(DGR);
+    typedef _Digraph Digraph;
+    TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
 
   private:
@@ -418,5 +420,5 @@
     bool local_os;
 
-    const DGR& _digraph;
+    const Digraph& _digraph;
 
     std::string _nodes_caption;
@@ -450,5 +452,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    DigraphWriter(const DGR& digraph, std::ostream& os = std::cout)
+    DigraphWriter(const Digraph& digraph, std::ostream& os = std::cout)
       : _os(&os), local_os(false), _digraph(digraph),
         _skip_nodes(false), _skip_arcs(false) {}
@@ -458,5 +460,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const DGR& digraph, const std::string& fn)
+    DigraphWriter(const Digraph& digraph, const std::string& fn)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _digraph(digraph),
         _skip_nodes(false), _skip_arcs(false) {
@@ -471,5 +473,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const DGR& digraph, const char* fn)
+    DigraphWriter(const Digraph& digraph, const char* fn)
       : _os(new std::ofstream(fn)), local_os(true), _digraph(digraph),
         _skip_nodes(false), _skip_arcs(false) {
@@ -504,13 +506,13 @@
   private:
 
-    template <typename TDGR>
-    friend DigraphWriter<TDGR> digraphWriter(const TDGR& digraph,
-                                             std::ostream& os);
-    template <typename TDGR>
-    friend DigraphWriter<TDGR> digraphWriter(const TDGR& digraph,
-                                             const std::string& fn);
-    template <typename TDGR>
-    friend DigraphWriter<TDGR> digraphWriter(const TDGR& digraph,
-                                             const char *fn);
+    template <typename DGR>
+    friend DigraphWriter<DGR> digraphWriter(const DGR& digraph, 
+                                            std::ostream& os);
+    template <typename DGR>
+    friend DigraphWriter<DGR> digraphWriter(const DGR& digraph,
+                                            const std::string& fn);
+    template <typename DGR>
+    friend DigraphWriter<DGR> digraphWriter(const DGR& digraph,
+                                            const char *fn);
 
     DigraphWriter(DigraphWriter& other)
@@ -537,5 +539,5 @@
   public:
 
-    /// \name Writing Rules
+    /// \name Writing rules
     /// @{
 
@@ -640,5 +642,5 @@
     }
 
-    /// \name Section Captions
+    /// \name Section captions
     /// @{
 
@@ -667,5 +669,5 @@
     }
 
-    /// \name Skipping Section
+    /// \name Skipping section
     /// @{
 
@@ -723,6 +725,6 @@
 
       if (label == 0) {
-        IdMap<DGR, Node> id_map(_digraph);
-        _writer_bits::MapLess<IdMap<DGR, Node> > id_less(id_map);
+        IdMap<Digraph, Node> id_map(_digraph);
+        _writer_bits::MapLess<IdMap<Digraph, Node> > id_less(id_map);
         std::sort(nodes.begin(), nodes.end(), id_less);
       } else {
@@ -808,6 +810,6 @@
 
       if (label == 0) {
-        IdMap<DGR, Arc> id_map(_digraph);
-        _writer_bits::MapLess<IdMap<DGR, Arc> > id_less(id_map);
+        IdMap<Digraph, Arc> id_map(_digraph);
+        _writer_bits::MapLess<IdMap<Digraph, Arc> > id_less(id_map);
         std::sort(arcs.begin(), arcs.end(), id_less);
       } else {
@@ -884,5 +886,5 @@
   public:
 
-    /// \name Execution of the Writer
+    /// \name Execution of the writer
     /// @{
 
@@ -914,39 +916,12 @@
   };
 
-  /// \ingroup lemon_io
-  ///
   /// \brief Return a \ref DigraphWriter class
   ///
   /// This function just returns a \ref DigraphWriter class.
-  ///
-  /// With this function a digraph can be write to a file or output
-  /// stream in \ref lgf-format "LGF" format with several maps and
-  /// attributes. For example, with the following code a network flow
-  /// problem can be written to the standard output, i.e. a digraph
-  /// with a \e capacity map on the arcs and \e source and \e target
-  /// nodes:
-  ///
-  ///\code
-  ///ListDigraph digraph;
-  ///ListDigraph::ArcMap<int> cap(digraph);
-  ///ListDigraph::Node src, trg;
-  ///  // Setting the capacity map and source and target nodes
-  ///digraphWriter(digraph, std::cout).
-  ///  arcMap("capacity", cap).
-  ///  node("source", src).
-  ///  node("target", trg).
-  ///  run();
-  ///\endcode
-  ///
-  /// For a complete documentation, please see the \ref DigraphWriter
-  /// class documentation.
-  /// \warning Don't forget to put the \ref DigraphWriter::run() "run()"
-  /// to the end of the parameter list.
   /// \relates DigraphWriter
-  /// \sa digraphWriter(const TDGR& digraph, const std::string& fn)
-  /// \sa digraphWriter(const TDGR& digraph, const char* fn)
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph, std::ostream& os) {
-    DigraphWriter<TDGR> tmp(digraph, os);
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       std::ostream& os) {
+    DigraphWriter<Digraph> tmp(digraph, os);
     return tmp;
   }
@@ -956,9 +931,8 @@
   /// This function just returns a \ref DigraphWriter class.
   /// \relates DigraphWriter
-  /// \sa digraphWriter(const TDGR& digraph, std::ostream& os)
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph,
-                                    const std::string& fn) {
-    DigraphWriter<TDGR> tmp(digraph, fn);
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const std::string& fn) {
+    DigraphWriter<Digraph> tmp(digraph, fn);
     return tmp;
   }
@@ -968,20 +942,21 @@
   /// This function just returns a \ref DigraphWriter class.
   /// \relates DigraphWriter
-  /// \sa digraphWriter(const TDGR& digraph, std::ostream& os)
-  template <typename TDGR>
-  DigraphWriter<TDGR> digraphWriter(const TDGR& digraph, const char* fn) {
-    DigraphWriter<TDGR> tmp(digraph, fn);
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const char* fn) {
+    DigraphWriter<Digraph> tmp(digraph, fn);
     return tmp;
   }
 
-  template <typename GR>
+  template <typename Graph>
   class GraphWriter;
 
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, std::ostream& os = std::cout);
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, const std::string& fn);
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, const char* fn);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph,
+                                 std::ostream& os = std::cout);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const std::string& fn);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const char* fn);
 
   /// \ingroup lemon_io
@@ -1000,10 +975,10 @@
   /// section as a \c '+' or a \c '-' prefix (depends on the direction
   /// of the arc) and the label of corresponding edge.
-  template <typename GR>
+  template <typename _Graph>
   class GraphWriter {
   public:
 
-    typedef GR Graph;
-    TEMPLATE_GRAPH_TYPEDEFS(GR);
+    typedef _Graph Graph;
+    TEMPLATE_GRAPH_TYPEDEFS(Graph);
 
   private:
@@ -1013,5 +988,5 @@
     bool local_os;
 
-    const GR& _graph;
+    const Graph& _graph;
 
     std::string _nodes_caption;
@@ -1045,5 +1020,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    GraphWriter(const GR& graph, std::ostream& os = std::cout)
+    GraphWriter(const Graph& graph, std::ostream& os = std::cout)
       : _os(&os), local_os(false), _graph(graph),
         _skip_nodes(false), _skip_edges(false) {}
@@ -1053,5 +1028,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const GR& graph, const std::string& fn)
+    GraphWriter(const Graph& graph, const std::string& fn)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _graph(graph),
         _skip_nodes(false), _skip_edges(false) {
@@ -1066,5 +1041,5 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const GR& graph, const char* fn)
+    GraphWriter(const Graph& graph, const char* fn)
       : _os(new std::ofstream(fn)), local_os(true), _graph(graph),
         _skip_nodes(false), _skip_edges(false) {
@@ -1099,12 +1074,14 @@
   private:
 
-    template <typename TGR>
-    friend GraphWriter<TGR> graphWriter(const TGR& graph, std::ostream& os);
-    template <typename TGR>
-    friend GraphWriter<TGR> graphWriter(const TGR& graph,
-                                        const std::string& fn);
-    template <typename TGR>
-    friend GraphWriter<TGR> graphWriter(const TGR& graph, const char *fn);
-
+    template <typename GR>
+    friend GraphWriter<GR> graphWriter(const GR& graph,
+                                       std::ostream& os);
+    template <typename GR>
+    friend GraphWriter<GR> graphWriter(const GR& graph,
+                                       const std::string& fn);
+    template <typename GR>
+    friend GraphWriter<GR> graphWriter(const GR& graph,
+                                       const char *fn);
+    
     GraphWriter(GraphWriter& other)
       : _os(other._os), local_os(other.local_os), _graph(other._graph),
@@ -1130,5 +1107,5 @@
   public:
 
-    /// \name Writing Rules
+    /// \name Writing rules
     /// @{
 
@@ -1192,8 +1169,8 @@
       checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
       _writer_bits::MapStorageBase<Edge>* forward_storage =
-        new _writer_bits::GraphArcMapStorage<GR, true, Map>(_graph, map);
+        new _writer_bits::GraphArcMapStorage<Graph, true, Map>(_graph, map);
       _edge_maps.push_back(std::make_pair('+' + caption, forward_storage));
       _writer_bits::MapStorageBase<Edge>* backward_storage =
-        new _writer_bits::GraphArcMapStorage<GR, false, Map>(_graph, map);
+        new _writer_bits::GraphArcMapStorage<Graph, false, Map>(_graph, map);
       _edge_maps.push_back(std::make_pair('-' + caption, backward_storage));
       return *this;
@@ -1209,9 +1186,9 @@
       checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
       _writer_bits::MapStorageBase<Edge>* forward_storage =
-        new _writer_bits::GraphArcMapStorage<GR, true, Map, Converter>
+        new _writer_bits::GraphArcMapStorage<Graph, true, Map, Converter>
         (_graph, map, converter);
       _edge_maps.push_back(std::make_pair('+' + caption, forward_storage));
       _writer_bits::MapStorageBase<Edge>* backward_storage =
-        new _writer_bits::GraphArcMapStorage<GR, false, Map, Converter>
+        new _writer_bits::GraphArcMapStorage<Graph, false, Map, Converter>
         (_graph, map, converter);
       _edge_maps.push_back(std::make_pair('-' + caption, backward_storage));
@@ -1271,5 +1248,5 @@
     /// Add an arc writing rule to writer.
     GraphWriter& arc(const std::string& caption, const Arc& arc) {
-      typedef _writer_bits::GraphArcLookUpConverter<GR> Converter;
+      typedef _writer_bits::GraphArcLookUpConverter<Graph> Converter;
       Converter converter(_graph, _edge_index);
       _writer_bits::ValueStorageBase* storage =
@@ -1279,5 +1256,5 @@
     }
 
-    /// \name Section Captions
+    /// \name Section captions
     /// @{
 
@@ -1306,5 +1283,5 @@
     }
 
-    /// \name Skipping Section
+    /// \name Skipping section
     /// @{
 
@@ -1362,6 +1339,6 @@
 
       if (label == 0) {
-        IdMap<GR, Node> id_map(_graph);
-        _writer_bits::MapLess<IdMap<GR, Node> > id_less(id_map);
+        IdMap<Graph, Node> id_map(_graph);
+        _writer_bits::MapLess<IdMap<Graph, Node> > id_less(id_map);
         std::sort(nodes.begin(), nodes.end(), id_less);
       } else {
@@ -1447,6 +1424,6 @@
 
       if (label == 0) {
-        IdMap<GR, Edge> id_map(_graph);
-        _writer_bits::MapLess<IdMap<GR, Edge> > id_less(id_map);
+        IdMap<Graph, Edge> id_map(_graph);
+        _writer_bits::MapLess<IdMap<Graph, Edge> > id_less(id_map);
         std::sort(edges.begin(), edges.end(), id_less);
       } else {
@@ -1523,5 +1500,5 @@
   public:
 
-    /// \name Execution of the Writer
+    /// \name Execution of the writer
     /// @{
 
@@ -1553,35 +1530,12 @@
   };
 
-  /// \ingroup lemon_io
-  ///
   /// \brief Return a \ref GraphWriter class
   ///
   /// This function just returns a \ref GraphWriter class.
-  ///
-  /// With this function a graph can be write to a file or output
-  /// stream in \ref lgf-format "LGF" format with several maps and
-  /// attributes. For example, with the following code a weighted
-  /// matching problem can be written to the standard output, i.e. a
-  /// graph with a \e weight map on the edges:
-  ///
-  ///\code
-  ///ListGraph graph;
-  ///ListGraph::EdgeMap<int> weight(graph);
-  ///  // Setting the weight map
-  ///graphWriter(graph, std::cout).
-  ///  edgeMap("weight", weight).
-  ///  run();
-  ///\endcode
-  ///
-  /// For a complete documentation, please see the \ref GraphWriter
-  /// class documentation.
-  /// \warning Don't forget to put the \ref GraphWriter::run() "run()"
-  /// to the end of the parameter list.
   /// \relates GraphWriter
-  /// \sa graphWriter(const TGR& graph, const std::string& fn)
-  /// \sa graphWriter(const TGR& graph, const char* fn)
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, std::ostream& os) {
-    GraphWriter<TGR> tmp(graph, os);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph,
+                                 std::ostream& os) {
+    GraphWriter<Graph> tmp(graph, os);
     return tmp;
   }
@@ -1591,8 +1545,7 @@
   /// This function just returns a \ref GraphWriter class.
   /// \relates GraphWriter
-  /// \sa graphWriter(const TGR& graph, std::ostream& os)
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, const std::string& fn) {
-    GraphWriter<TGR> tmp(graph, fn);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const std::string& fn) {
+    GraphWriter<Graph> tmp(graph, fn);
     return tmp;
   }
@@ -1602,8 +1555,7 @@
   /// This function just returns a \ref GraphWriter class.
   /// \relates GraphWriter
-  /// \sa graphWriter(const TGR& graph, std::ostream& os)
-  template <typename TGR>
-  GraphWriter<TGR> graphWriter(const TGR& graph, const char* fn) {
-    GraphWriter<TGR> tmp(graph, fn);
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const char* fn) {
+    GraphWriter<Graph> tmp(graph, fn);
     return tmp;
   }
@@ -1700,5 +1652,5 @@
   public:
 
-    /// \name Section Writers
+    /// \name Section writers
     /// @{
 
@@ -1767,5 +1719,5 @@
 
 
-    /// \name Execution of the Writer
+    /// \name Execution of the writer
     /// @{
 
@@ -1795,16 +1747,8 @@
   };
 
-  /// \ingroup lemon_io
-  ///
   /// \brief Return a \ref SectionWriter class
   ///
   /// This function just returns a \ref SectionWriter class.
-  ///
-  /// Please see SectionWriter documentation about the custom section
-  /// output.
-  ///
   /// \relates SectionWriter
-  /// \sa sectionWriter(const std::string& fn)
-  /// \sa sectionWriter(const char *fn)
   inline SectionWriter sectionWriter(std::ostream& os) {
     SectionWriter tmp(os);
@@ -1816,5 +1760,4 @@
   /// This function just returns a \ref SectionWriter class.
   /// \relates SectionWriter
-  /// \sa sectionWriter(std::ostream& os)
   inline SectionWriter sectionWriter(const std::string& fn) {
     SectionWriter tmp(fn);
@@ -1826,5 +1769,4 @@
   /// This function just returns a \ref SectionWriter class.
   /// \relates SectionWriter
-  /// \sa sectionWriter(std::ostream& os)
   inline SectionWriter sectionWriter(const char* fn) {
     SectionWriter tmp(fn);
